function empInt = performEmpInt(g,x,mu,tol)

% make sure all entries in x and mu are column vectors
  x = cellfun(@(x) x(:),x,'UniformOutput',false);
  mu = cellfun(@(mu) mu(:),mu,'UniformOutput',false);

% apply repmat for evaluating all combinatons  
  X = cellfun(@(x) repmat(x,1,numel(mu{1})),x,'UniformOutput',false);
  Mu = cellfun(@(mu) repmat(mu',numel(x{1}),1),mu,'UniformOutput',false);
  G = g(X{:},Mu{:});

% perform empirical interpolation for given method  
  [empInt.Basis,S_ind,T_ind,empInt.Gbar,empInt.eps_star] = empIntAlg(G,tol);


% postprocessing
  empInt.g = g;
  empInt.Q_max = length(empInt.eps_star);
  empInt.T = cellfun(@(x) x(T_ind),x,'UniformOutput',false);
  empInt.S = cellfun(@(mu) mu(S_ind),mu,'UniformOutput',false);
